
package de.ivu.elect.presentation.ergebnis.exchange;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.ergebnis.boundary.SitzeExporter;
import de.ivu.elect.business.ergebnis.boundary.SitzeExtendedDAO;
import de.ivu.elect.business.ergebnis.control.SitzeExportContext;
import de.ivu.elect.business.ergebnis.control.SitzeExportContext.SitzeExportContextBuilder;
import de.ivu.elect.business.ergebnis.control.SitzeExportObject;
import de.ivu.elect.business.ergebnis.entity.Ergebnisart;
import de.ivu.elect.business.exchange.control.AbstractExporter;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.exchange.ExportDescription;

@Named(SitzeExportSearchView.COMPONENT_NAME)
@View(viewId = SitzeExportSearchView.VIEW_ID, useCase = UseCasePermission.STIMMEN_EXPORTIEREN)
public class SitzeExportSearchView extends AbstractErgebnisExportSearchView<SitzeExportObject, SitzeExportContext> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "sitzeExportSearchView";

  public static final String VIEW_ID = "/ergebnis/sitze-export-search.xhtml";

  @Inject
  private transient SitzeExporter sitzeExporter;

  @Inject
  private transient SitzeExportDescription sitzeExportDescription;

  @Inject
  private transient SitzeExtendedDAO sitzeExtendedDao;

  public SitzeExportSearchView() {
    super();
  }

  @Override
  protected AbstractExporter<SitzeExportObject, SitzeExportContext> getExporter() {
    return sitzeExporter;
  }

  @Override
  protected SitzeExportContext getContext() {
    SitzeExportContextBuilder builder = new SitzeExportContextBuilder(getSelectedWahl());

    buildContext(builder);

    return builder.build();
  }

  @Override
  public ExportDescription getExportDescription() {
    return sitzeExportDescription;
  }

  @Override
  protected boolean hatDaten(Ergebnisart searchedErgebnisart) {
    long result = sitzeExtendedDao.findByCountSitzeByWahlAndErgebnisart(getSelectedWahl(), searchedErgebnisart);

    return result != 0L;
  }
}
